module Main where

import Maze
#if defined(STRATEGIES)
#if defined(EVAL_STRATEGIES) 
--import Control.Parallel
import Control.Parallel.Strategies
import Control.DeepSeq
#elif defined(SM_STRATEGIES)
import Control.Parallel.Strategies
import Control.Parallel
#else
import Control.Parallel.Strategies
import Control.Parallel
#endif
#else 
import Control.DeepSeq
#endif 

main = print (searchp 4 isExit continue sucessors [] node1)
#if defined(STRATEGIES)
#if defined(EVAL_STRATEGIES) 
parmap f list = map f list `using` parList rdeepseq
#elif defined(SM_STRATEGIES) 
parmap f list = map f list `using` parList rdeepseq
#else
parmap f list = map f list  `using` parList rnf
#endif
#else 
parmap f list = map f list
#endif 

node1 :: Node
node1 = (True,1000,1000) 
--R (True,0,10) 8 6

sucessors (True,1000,1000)=[(False,7,10),(False,6,10),(True,5,9),(False,4,10),(False,3,10),(False,2,10),(False,1,10)]
--sucessors (True,1000,1000)= [(False,7,8),(False,6,8),(False,5,8),(False,4,8),(False,3,8),(False,2,8),(True,1,8)]
--sucessors (True,1000,1000)= [(False,7,8),(False,6,8),(False,5,8),(False,4,8),(False,3,8),(False,2,8),(True ,1,6)]
sucessors x = rsucessors 7 x

searchp :: (NFData a)=> Int -> (a -> Bool) -> (a->Bool) -> (a -> [a]) -> [a] -> a -> [a]
searchp 0 isExit continue successors solutions node = search isExit continue successors solutions node
searchp t isExit continue successors solutions node  
 | isExit node		 = node:solutions
 | continue node	 = let list = parmap (searchp (t-1) isExit continue successors (node:solutions)) (successors node)
			    in list `seq` firstSolution list    
 | otherwise		 = []



search :: (NFData a)=> (a -> Bool) -> (a->Bool) -> (a -> [a]) -> [a] -> a -> [a]
search isExit continue successors solutions node  
 | isExit node		 = node:solutions
 | continue node	 = firstSolution (map (search isExit continue successors (node:solutions)) (successors node))
 | otherwise		 = []




firstSolution :: [[a]] -> [a]
firstSolution [] = []
firstSolution ([]:xs) = firstSolution xs
firstSolution (x:xs)  = x
 
  
