#!/bin/bash

function runIt_setup {
# Compiler (32-bit)
# ghc="/u1/staff/hwloidl/OPT/bin/ghc-6.12.1.20100330"
# Compiler (64-bit)
# ghc="/u1/staff/hwloidl/OPT/x86_64-unknown-linux/bin/ghc-6.12.2"
# HEAD
# ghc="/u1/staff/hwloidl/OPT/x86_64-unknown-linux/bin/ghc-6.13.20100405"

# iterate over ghcs

## slightly older versions of 6.13
# if [ "`hw_os`" = "x86_64-unknown-linux" ]
#   then ghcs="/u1/staff/hwloidl/OPT/x86_64-unknown-linux/bin/ghc-6.13.20100405"
#   else ghcs="/u1/staff/hwloidl/OPT/bin/ghc-6.13.20100401"
# fi

#if [ "`hw_os`" = "x86_64-unknown-linux" ]
#  then ghcs="/u1/staff/hwloidl/OPT/x86_64-unknown-linux/bin/ghc-6.12.2 /u1/staff/hwloidl/OPT/x86_64-unknown-linux/bin/ghc-6.13.20100520"
#  else ghcs="/u1/staff/hwloidl/OPT/bin/ghc-6.12.2 /u1/staff/hwloidl/OPT/bin/ghc-6.13.20100401"
#fi

# latest version, but still using a ROOT GC policy on sparks
# if [ "`hw_os`" = "x86_64-unknown-linux" ]
#   then ghcs="/u1/staff/hwloidl/OPT/x86_64-unknown-linux/bin/ghc-6.13.20100520"
#   else ghcs="/u1/staff/hwloidl/OPT/i386-unknown-linux/bin/ghc-6.13.20100520"
# fi

# the ghc versions to use; runIt will iterate over this list
ghcs="ghc"

# extra="-O"
# extra=""

# iterate over these
# extras="-O -O2"
extras="-O"

fixes=""

# only one variant
variant="BEST"
}

function spdups  {
  log=${1-"LOG"}
  cat ${log} |   # feed log file
  sed -n '/SPARKS/p;/^\*/p;/Total time/p' | # filter interesting lines
  sed '/Total time/a\X' | # add separation marker
  sed '/SPARKS/d;s/^.*PEs \([0-9]*\)/\1/;s/^.*Total time[^(]*[(][^0-9]*\([.0-9]*\).*\$/\1/g' | # extract only PE no. and  runtimes
  sed '/^\*\*/a\X'  | # add separation marker
  sed ':a;N;$!ba;s/\n/ /g' | # bring all on same line
  sed 's/X/\n/g' | # add newlines at separation markers
  sed '1d' | 
  awk '/^[ ]*\*/ { print "# " $_ };/^[ ]*[0-9]/ { if ( seq == 0) seq = $1 ; if ($2 > 0) print $1 " " seq/$2; }'  # calculate speedup
}
 