{-
	a little program to generate sparse matrices
	command line args: dimension and fill factor(i.e. ratio of zero entries)

	UK, July 00
-}
import System (getArgs)
import Random
import Matrix
import LU

{- Haskell 1.2 version

main = 
	randomIO (0,9999999) >>= \ rands ->
	getArgs >>= \[d,sparse]  ->
	putStr ("d " ++  show (read d::Int) ++ "sparse " ++ show (read (sparse)::Double)) >>
      	let 
	   a = makeSMat (read d) (read sparse) rands
	in 
	 putStr (show a ++ "\n determinant: " ++ show (determinant a) ++ "\n")

-}

main = do
        args <- getArgs
        g <- getStdGen
        let 
          n = read (args!!0) :: Int       -- size of random matrix
          m = read (args!!1) :: Integer   -- size of random matrix
	  f = read (args!!2) :: Double    -- fill factor (as non-0 probability)
          -- g = mkStdGen 1701 -- deterministic input by fixing seed val
          l = map (`mod` m) $ randoms g :: [Integer]
	  a = makeSparseMatrix n m f l
          d = det (fmap toRational (unSqMatrix a)) -- det via LU of Arr
	putStr ("determinant a: " ++ show d ++ "\n")
	putStr ("a: " ++ show a)
	putStr (show n ++ "x" ++ show n ++ " matrix with element bound " ++ show m ++ " and fill factor of " ++ show f)


makeSparseMatrix :: Int -> Integer -> Double -> [Integer] -> SqMatrix Integer
makeSparseMatrix n m f rands 
  = listSqMatrix ((1,1),(n,n)) (take (n*n) (list rands))
    where list (a:b:rands) | a < limit = b : list rands
                           | otherwise = 0 : list rands
	  limit = (round (100*f))*m `div` 100


